/*
	Exemple de Laurent
	
	
	Utilisation de l'afficheur Lcd
	
*/

#define msTEMPO 10 // 1 simul 10 // Temporisation en ms

#include "mavin.h"
#include "ModuleFunction.h"

/* 

---- ModuleFunction.h -----

void LcdDisplay(char* msg1,char* msg2)

	Affichage d'un message sur la ligne 1 et 2

	Exemple :
	LcdDisplay( "Hello" , "World" );

	char msg[9] = "12345678"; LcdDisplay( Msg , "texte" );

----- mavin.h -----

void lcd_str_out( u08 row, u08 col, u08 *msg)

	Affichage d'une chaine en row(ligne) et col(colonne)
	row : 1 ou 2
	col : 1  8
	msg : pointeur vers une chaine (unsigned char)

void lcd_char_out( u08 row, u08 col, u08 data)

	Affichage d'un caractere en row(ligne) et col(colonne)
	ligne : 1 ou 2
	colonne : 1  8
	data : unsigned char (u08)
	


----- niveau inferieur (primitive) -----

void lcd_line_clr( u08 line )

	Efface une ligne ( affiche 8 espaces )
	line : 1 ou 2


void lcd_position( u08 row, u08 col )

	Prepare la position ligne/colonne du prochain affichage
	row : 1 ou 2
	col : 1  8
	
void lcd_out( u08 data )

	Affiche un caractere en position courante
	date : unsigned char a afficher


void lcd_shift( u08 Lcd_shift_mode )

	Shift (decalage) vers la droite ou gauche de l'affichage
	
	Lcd_shift_mode : 
		LCD_RIGHT 0
		LCD_LEFT  1

	Attention a peut planter l'affichage ...



*/

#define Tempo() mSecDelay(msTEMPO) // Macro


int main(void)
{
	// Local declaration
	
	char msg[9] = "12345678"; // 8 chars + 0x00 (fin de chaine)
	
	u08 i;


	Initialize(); // Initialize Mavin library
	
	
	while(1)
	{
		LcdDisplay( "Hello" , "World" );
		
		Tempo();
		
		LcdDisplay( msg , "texte" );
		
		Tempo();
		
		
		// Il faut "caster' la chaine pour ne pas avoir de warning
		lcd_str_out( 2,1, ( u08 * ) " WORLD " );
		
		Tempo();
		
		// Il faut "caster' la chaine pour ne pas avoir de warning
		lcd_str_out( 2,1, ( u08 * ) msg );
		
		Tempo();
		
		for( i=1; i<9 ; i++){
		
			// Il faut "caster' le char pour ne pas avoir de warning
			lcd_char_out( 2, i, (u08) msg[8-i] );
			Tempo();
			
		} // End for
		
		
		for( i=1; i<9 ; i++){
		
			lcd_shift( LCD_RIGHT );
			Tempo();
			
		} // End for
		

		for( i=1; i<9 ; i++){
		
			lcd_shift( LCD_LEFT );
			Tempo();
			
		} // End for

		
	} // End while(1)

	
} // End main
