/*
	Exemple du Ma-Vin Programmer's Guide
	Page 28 & 32
	
	Afficheur 7 Segments
	
	Programme a amliorer ;o)
	
	Module 7 Segments    in slot #1
	
*/

#include "mavin.h"
#include "ModuleFunction.h"




int main(void)
{
	// Local declaration
	u08 i,data,digit;
	
	// Table de conversion digit(hexa) ->  7 segments
	//    
	char segment[16]={0x48,0xeb,0x8c,0x89,0x2b,0x19,0x18,
		0x4b,0x08,0x09,0x0a,0x38,0x5c,0xa8,0x1c,0x1e};

	Initialize(); // Initialize Mavin library
	

	//-----fnd port IO setup for 7segment operation---------
	// PortB 0,1,2 OUTPUT pour pilotage du 74595
	sbi(DDRB , 0); // 595.p14.DS : Serial Data
	sbi(DDRB , 1); // 595.p11.SH_CP : Shift register clock in 
	sbi(DDRB , 2); // 595.p12.ST_CP : Storage register clock in
	
	//----------- Japonais -----------
	// Initialisation suite
	cbi(PORTB,2);	// low on store 
	
	while(1)
	{
		for( digit=0; digit<16; digit++)
		{
		
			//------------ Japonais --------------
			
			data=segment[digit]; // digit -> segments
			
			for( i=0; i<8; i++ ){
			
				// Pour chaque bit :
				if( (data<<i) & 0x80 ) {
				
					// Si le bit est a 1 :
					sbi(PORTB,0);	// 595 Serial data=1
					
				} else {
				
					cbi(PORTB,0);	// 595 Serial data=0
					
				} // End Else/If
				
				//------------ Japonais ----------------
				// Un pulse sur 595.Shift clock 
				sbi(PORTB,1);
				cbi(PORTB,1);
			} // End for(i) bits
			
			//--------- Japonais -------------
			// Strobe pour passer le shift register sur output register
			
			sbi(PORTB,2);
			
			
			mSecDelay(100); // Affichage pendant 1/10 Sec
			
		} // End for(digit)
		
	} // End while(1)

	
} // End main
